#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "gente.h"
#include "stub.h"

#define	MAXHOSTNAME	256
#define RPC_PORT	11111
#define RPC_HOST	"localhost"
#define CERTO		0
#define ERRADO		1

#define BUFFER_SIZE 256

int rpc_error = 0;

int sstub (int argc, char **argv)
{
int s;				// identificador do socket
int len;			// tamanho da mensagem a ser enviada
struct sockaddr_in sa;		// estrutura de endereo do socket
struct sockaddr_in res;		// estrutura de endereco de resposta
int res_len = 16;		// tamanho do endereco de resposta
struct hostent *hp;		// estrutura de nomes e enderecos de host 
char message[BUFFER_SIZE] = ""; 	// buffer recebimento
char localhost[MAXHOSTNAME] = "";	// buffer para nome do host local
int a=0,b=0;
int op = 0;
int estado = 0;
int result = 0;
char *pt = 0;
int i=0;

if (argc < 2)
  {
  fprintf(stderr,"Use: servo porta\n");
  exit(1);
  }

// descobre o nome do host local e pega seu endereco

gethostname(localhost,MAXHOSTNAME);
if ((hp= gethostbyname(localhost)) == NULL)
  {
  fprintf(stderr,"Host local %d desconhecido!\n",argv[1]);
  exit(2);
  }

// copia endereco, familia e numero de porta para o socket

bcopy((char*) hp->h_addr,(char*) &(sa.sin_addr), hp->h_length);
sa.sin_family = hp->h_addrtype;
sa.sin_port = atoi(argv[1]);
bzero(&(sa.sin_zero), 8);

// cria um socket dizendo a familia de protocolos e o tipo: UDP/IP
// O socket so especifica o tipo de protocolo, nenhum endereco

if ((s=socket(hp->h_addrtype, SOCK_DGRAM, 0)) < 0)
  {
  fprintf(stderr,"Erro ao criar socket!\n");
  exit(3);
  }

// Associa-se a uma porta para que possa receber mensagens por ela

if (bind(s,(struct sockaddr*)&sa,sizeof sa) < 0)
  {
  fprintf(stderr,"Nao posso me associar a porta %s!\n",argv[1]);
  exit(4);
  }

while (1)
  {
  // Aguarda uma nova mensagem e executando o pedido

  len = BUFFER_SIZE;
  recvfrom(s,message,len,0,(struct sockaddr*)&res,&res_len);
  
  // Recupera parametros
  op = (int) message[0];
  for (pt=(char*)&a,i=0; i<4; ++pt,++i)
    *pt = message[1+i];
  for (pt=(char*)&b,i=0; i<4; ++pt,++i)
    *pt = message[5+i];

  fprintf(stderr,"Mensagem: ");
  for (i=0; i < 10; ++i)
    fprintf(stderr,"%d ",message[i]);
  fprintf(stderr,"\n");
  fprintf(stderr,"Operao %d, Parametros %d,%d\n",op,a,b);

  // Testa e executa operacao 
  op = (int) message[0];
  switch(op)
    {
    case SOMA: result = soma(a,b); estado = CERTO; break;
    case SUBA: result = suba(a,b); estado = CERTO; break;
    case MULTA: result = multa(a,b); estado = CERTO; break;
    case DIVA: result = diva(a,b); estado = CERTO; break;
    default: estado = ERRADO; break;
    }

  // Elabora aresposta e envia a quem perguntou (res)

  message[0] = (char) estado;
  for (pt=(char*)&result,i=0; i<4; ++pt,++i)
    message[1+i] = (char) *pt;
  message[5] = '\0';

  len = 6;

  // tenta enviar a resposta ateh que a mensagem va completa

  fprintf(stderr,"Resultado %d\n",result);
  while ((sendto(s,message,len,0,(struct sockaddr*)&res,res_len)) != len)
    ;
  }
close(s);
exit(0);
}