#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "stub.h"

#define RPC_PORT	11111
#define RPC_HOST	"localhost"
#define CERTO		0
#define ERRADO		1

#define BUFFER_SIZE 256

int rpc_error = 0;

int soma (int a, int b)
  { 
  int r;
  r = stub(SOMA,a,b);
  return r; 
  }
int suba (int a, int b) { return stub(SUBA,a,b); }
int multa (int a, int b) { return stub(MULTA,a,b); }
int diva (int a, int b) { return stub(DIVA,a,b); }

int stub (int op,int a, int b)
{
int s;				// identificador do socket
int len;			// tamanho da mensagem a ser enviada
struct sockaddr_in sa;		// estrutura de endereo do socket
struct sockaddr_in res;		// estrutura de endereco de resposta
int res_len = 16;		// tamanho do endereco de resposta
struct hostent *hp;		// estrutura de nomes e enderecos de host 
char message[BUFFER_SIZE] = ""; // buffer para envio e recebimento
int i=0, estado=0;
int resultado = 0;
char *pt;

// procura o endereco do host onde o servidor esta

if ((hp= gethostbyname(RPC_HOST)) == NULL)
  {
  fprintf(stderr,"RPC: Unknown Host %s\n",RPC_HOST);
  rpc_error = 2;
  return 0;
  }

// copia endereco, familia e numero de porta para o socket

// bcopy((char*) hp->h_addr,(char*) &(sa.sin_addr), hp->h_length);
sa.sin_addr = *((struct in_addr *) hp->h_addr);
sa.sin_family = hp->h_addrtype;
sa.sin_port = RPC_PORT;

// cria um socket dizendo a familia de protocolos e o tipo: UDP/IP

if ((s=socket(hp->h_addrtype, SOCK_DGRAM, 0)) < 0)
  {
  fprintf(stderr,"RPC: Erro ao criar socket!\n");
  rpc_error = 3;
  return 0;
  }

// Monta mensagem com codigo da operacao e parametros

message[0] = (char) op;
for (pt=(char*)&a,i=0; i<4; ++pt,++i)
  message[1+i] = (char) *pt;
for (pt=(char*)&b,i=0; i<4; ++pt,++i)
  message[5+i] = (char) *pt;
message[9] = '\0';

// Ou ento, copia inteiro para uma posicao de memoria
// E interessante ver que isso funciona mesmo sem alinhamento

//(int) message[1] = a;
//(int) message[5] = b;

//for (i=0; i < 10; ++i)
//  fprintf(stderr,"%d ",message[i]);

len = 10;

// Tenta mandar a mensagem ateh que tenha sido enviada completa

while (sendto(s,message,len,0,(struct sockaddr*)&sa,sizeof sa) != len)
    ;

// Se prepara para receber mensagem de tamanho maximo BUFFER_SIZE

len = BUFFER_SIZE;
recvfrom(s,message,len,0,(struct sockaddr*)&res,&res_len);

// Testa se a operacao foi efetuada corretamente

estado = (int) message[0];
if (estado != CERTO)
  {
  fprintf(stderr,"RPC: Erro ao processar a funcao!\n");
  rpc_error = 4;
  return 0;
  }

// Recupera o resultado para ser retornado

for (pt=(char*)&resultado,i=0; i<4; ++pt,++i)
  *pt = message[1+i];

close(s);
return resultado;
}